Bug 1751409 - Review Request: kokkos - C++ Performance Portability Programming
Summary: Review Request: kokkos - C++ Performance Portability Programming
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-09-11 22:57 UTC by Christoph Junghans
Modified: 2019-10-04 23:06 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-09-28 00:02:07 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Christoph Junghans 2019-09-11 22:57:02 UTC
Spec URL: https://junghans.fedorapeople.org/kokkos.spec
SRPM URL: https://junghans.fedorapeople.org/kokkos-3.0.0-0.1.190911git8bf914b.fc32.src.rpm
TaskID: https://koji.fedoraproject.org/koji/taskinfo?taskID=37614228
Description: Kokkos Core implements a programming model in C++ for writing performance portable applications targeting all major HPC platforms. For that purpose it provides abstractions for both parallel execution of code and data management.  Kokkos is designed to target complex node architectures with N-level memory hierarchies and multiple types of execution resources. It currently can use OpenMP, Pthreads and CUDA as backend programming models.
Fedora Account System Username: junghans

Is a dependency of the lammps package, too.

Comment 1 Robert-André Mauchin 🐧 2019-09-18 16:42:24 UTC
 - Please use YYYYMMDD:

Release:        0.1.190911git%{shortcommit}%{?dist}


Package approved.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 2-clause "Simplified" License",
     "Public domain BSD 2-clause "Simplified" License", "Expat License BSD
     2-clause "Simplified" License", "BSD 3-clause "New" or "Revised"
     License". 428 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/kokkos/review-
     kokkos/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib64/pkgconfig(pkgconf-
     pkg-config, uid_wrapper, libmodsecurity-devel, dontpanic-devel,
     ignition-transport-devel, ignition-math-devel)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: kokkos-3.0.0-0.1.190911git8bf914b.fc32.x86_64.rpm
          kokkos-devel-3.0.0-0.1.190911git8bf914b.fc32.x86_64.rpm
          kokkos-debuginfo-3.0.0-0.1.190911git8bf914b.fc32.x86_64.rpm
          kokkos-debugsource-3.0.0-0.1.190911git8bf914b.fc32.x86_64.rpm
          kokkos-3.0.0-0.1.190911git8bf914b.fc32.src.rpm
kokkos.x86_64: W: name-repeated-in-summary C Kokkos
kokkos-devel.x86_64: W: no-documentation
kokkos-devel.x86_64: W: no-manual-page-for-binary nvcc_wrapper
kokkos.src: W: name-repeated-in-summary C Kokkos
5 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 2 Gwyn Ciesla 2019-09-18 18:16:22 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/kokkos

Comment 3 Fedora Update System 2019-09-19 00:49:43 UTC
FEDORA-EPEL-2019-2f897a0c13 has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-2f897a0c13

Comment 4 Fedora Update System 2019-09-19 00:50:21 UTC
FEDORA-2019-d96dfb2367 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-d96dfb2367

Comment 5 Dave Love 2019-09-19 11:41:26 UTC
I was about to take this, as requested, but see I'm too late.  I'll comment anyhow as someone who might actually build against it.

My main concern with it is versioning.  Why is it using a snapshot, not a release version?
Then, the soname should have a semantic version, not the "release" version.

It should use %ldconfig_scriptlets for use in EPEL (though I don't know if that's just EPEL7), and I'd have thought it should ship docs.

Given that it's a performance library, with support for "aggressive vectorization", would it not benefit from better compilation options, and use of devtoolset-8 for el7?  Possibly also target-specific builds.  (I don't actually know where the performance comes from.)

Can you not use the ROCm option to provide GPU support for Fedora?  I don't know if there's a good reason ROCm isn't in EPEL, where it would be more useful.

I haven't had a chance to see how a separate build would integrate with possible packaging of Trilinos.  Is that clear?  I haven't had a chance to re-examine the older Trilinos packaging I did.

Comment 6 Christoph Junghans 2019-09-19 13:21:59 UTC
(In reply to Dave Love from comment #5)
> I was about to take this, as requested, but see I'm too late.  I'll comment
> anyhow as someone who might actually build against it.
Good point, thanks for your inputs.

> My main concern with it is versioning.  Why is it using a snapshot, not a
> release version?
> Then, the soname should have a semantic version, not the "release" version.
Yeah, I wanted to build a snapshot before the actual 3.0 release to see if everything works, kokkos is usually bundled with packages, so un bundling it might give us some surprises. And the library aren't abi-compatible between version see https://github.com/kokkos/kokkos/pull/2291#issuecomment-529268933, so having the full version should be ok.

> It should use %ldconfig_scriptlets for use in EPEL (though I don't know if
> that's just EPEL7), and I'd have thought it should ship docs.
I am not planning to package it for EPEL7, EPEL8 yes, but not 7. If you want to take a shot at it, please let me know.

> Given that it's a performance library, with support for "aggressive
> vectorization", would it not benefit from better compilation options, and
> use of devtoolset-8 for el7?  Possibly also target-specific builds.  (I
> don't actually know where the performance comes from.)
Optimization are on my To-Do list, so stay tuned.

 > Can you not use the ROCm option to provide GPU support for Fedora?  I don't
> know if there's a good reason ROCm isn't in EPEL, where it would be more
> useful.
I was planning to compile it with OpenMP offload for the device parallelization in the next iteration.

> I haven't had a chance to see how a separate build would integrate with
> possible packaging of Trilinos.  Is that clear?  I haven't had a chance to
> re-examine the older Trilinos packaging I did.
I believe there is some work going on to allow Trilinos to be compiled with external kokkos.

Comment 7 Fedora Update System 2019-09-20 02:56:16 UTC
kokkos-3.0.0-0.1.190912gitd93e239.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-d96dfb2367

Comment 8 Fedora Update System 2019-09-20 03:44:28 UTC
kokkos-3.0.0-0.1.190912gitd93e239.el8 has been pushed to the Fedora EPEL 8 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-2f897a0c13

Comment 9 Fedora Update System 2019-09-28 00:02:07 UTC
kokkos-3.0.0-0.1.190912gitd93e239.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2019-10-04 23:06:17 UTC
kokkos-3.0.0-0.1.190912gitd93e239.el8 has been pushed to the Fedora EPEL 8 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.